export interface GlobalFetchContext {
    initCOntent?: FetchInit;
    resContent?: Response;
}
export declare type FetchInit = {
    input: RequestInfo | URL;
    init?: RequestInit | undefined;
};
export declare type BeforeFetchRequest = (body: FetchInit, context: GlobalFetchContext) => Promise<FetchInit>;
export declare type AfterFetchRequest = (body: FetchInit, context: GlobalFetchContext) => void;
export declare type BeforeFetchResponse = (context: GlobalFetchContext) => Promise<Response>;
export declare type AfterFetchResponse = (body: Response, context: GlobalFetchContext) => void;
export interface FetchHooks {
    beforeFetchRequest?: BeforeFetchRequest;
    afterFetchRequest?: AfterFetchRequest;
    beforeFetchResponse?: BeforeFetchResponse;
    afterFetchResponse?: AfterFetchResponse;
}
export interface FetchParameter extends FetchHooks {
    originFetch: typeof window.fetch;
}
/**
 * fetch hook
 * @param FetchParameter
 * @returns fetch
 */
export declare const fetchHook: ({ originFetch, beforeFetchRequest, afterFetchRequest, beforeFetchResponse, afterFetchResponse, }: FetchParameter) => (input: RequestInfo | URL, init?: RequestInit | undefined) => Promise<Response>;
