const fetchHook = ({
  originFetch,
  beforeFetchRequest,
  afterFetchRequest,
  beforeFetchResponse,
  afterFetchResponse
}) => {
  const globalContext = {};
  const selfFetchproxy = async (input, init) => {
    const originFetchInit = { input, init };
    globalContext.initCOntent = originFetchInit;
    const fetchInit = beforeFetchRequest ? await beforeFetchRequest(originFetchInit, globalContext) : originFetchInit;
    afterFetchRequest && afterFetchRequest(originFetchInit, globalContext);
    beforeFetchResponse && beforeFetchResponse(globalContext);
    const originResponse = await originFetch(fetchInit.input, fetchInit.init);
    globalContext.resContent = originResponse;
    const response = afterFetchResponse && afterFetchResponse(originResponse, globalContext);
    if (response)
      return response;
    return originResponse;
  };
  return selfFetchproxy;
};

export { fetchHook };
