const xmlHttpReauestHook = ({
  originXML,
  beforeXmlOpen,
  afterXmlOpen,
  beforeXmlSend,
  afterXmlSend,
  beforeXmlResponse,
  afterXmlResponese
}) => {
  return class SelfXmlHttpRequest extends originXML {
    globalContext = {};
    constructor() {
      super();
    }
    open(method, url, async = true, username, password) {
      const originOpenBody = { method, url, async, username, password };
      this.globalContext.openContent = originOpenBody;
      const body = beforeXmlOpen ? beforeXmlOpen(originOpenBody, this.globalContext) : originOpenBody;
      originXML.prototype.open.apply(this, [
        body.method,
        body.url,
        body.async,
        body.username,
        body.password
      ]);
      afterXmlOpen && afterXmlOpen(body, this.globalContext);
    }
    send(originBody) {
      this.globalContext.sendContent = originBody;
      const body = beforeXmlSend ? beforeXmlSend(originBody, this.globalContext) : originBody;
      originXML.prototype.send.call(this, body);
      afterXmlSend && afterXmlSend(body, this.globalContext);
      const responseBody = beforeXmlResponse && beforeXmlResponse(this.globalContext);
      if (responseBody) {
        Object.defineProperty(this, "response", {
          value: responseBody,
          configurable: true
        });
        Object.defineProperty(this, "responseText", {
          value: responseBody,
          configurable: true
        });
        Object.defineProperty(this, "status", {
          value: 200,
          configurable: true
        });
      }
      this.addEventListener("readystatechange", () => {
        if (this.readyState === 4) {
          this.globalContext.responseContext = this.response;
          afterXmlResponese && afterXmlResponese(this.response, this.globalContext);
        }
      });
    }
  };
};

export { xmlHttpReauestHook };
