'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const createStream = (str) => {
  const stream = new ReadableStream({
    start(controller) {
      controller.enqueue(new TextEncoder().encode(str));
      controller.close();
    }
  });
  return stream;
};
const replaceFetchDate = (body, data, extracOptions) => {
  const bodyInit = {
    ok: body.ok,
    redirected: body.redirected,
    type: body.type,
    url: body.url,
    bodyUsed: body.bodyUsed
  };
  const stream = createStream(JSON.stringify(data));
  const response = new Response(stream, {
    ...bodyInit,
    headers: body.headers,
    status: 200,
    statusText: body.statusText,
    ...extracOptions
  });
  return response;
};

exports.createStream = createStream;
exports.replaceFetchDate = replaceFetchDate;
